scala.tools.nsc.symtab.classfile

# ClassfileParser

###
Related Doc: package classfile

#### abstract class ClassfileParser extends AnyRef

This abstract class implements a class file parser.

Source
  ClassfileParser.scala
Version

  1.0

Linear Supertypes
AnyRef, Any
Known Subclasses
ICodeReader, icodeReader
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ClassfileParser
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Instance Constructors

1. #### new ClassfileParser()

### Type Members

1. #### class ConstantPool extends AnyRef

   Constructor of this class should not be called directly, use `newConstantPool` instead.

   Constructor of this class should not be called directly, use `newConstantPool` instead.

   Attributes
     protected

2. #### case class InnerClassEntry (external: Int, outer: Int, name: Int, jflags: JavaAccFlags) extends Product with Serializable

   An entry in the InnerClasses attribute of this class file.

3. #### class LazyAliasType extends (symbolTable)#LazyType with (symbolTable)#FlagAgnosticCompleter

4. #### abstract type ThisConstantPool <: ConstantPool

   Attributes
     protected

5. #### class TypeParamsType extends (symbolTable)#LazyType with (symbolTable)#FlagAgnosticCompleter

### Abstract Value Members

1. #### abstract def classFileLookup: ClassFileLookup[AbstractFile]

   The way of the class file lookup used by the compiler.

2. #### abstract val loaders: SymbolLoaders { val symbolTable: scala.tools.nsc.symtab.classfile.ClassfileParser.<refinement>.type }

3. #### abstract def lookupMemberAtTyperPhaseIfPossible(sym: (symbolTable)#Symbol, name: (symbolTable)#Name): (symbolTable)#Symbol

   If typer phase is defined then perform member lookup of a symbol `sym` at typer phase.

   If typer phase is defined then perform member lookup of a symbol `sym` at typer phase. This method results from refactoring. The original author of the logic that uses typer phase didn't explain why we need to force infos at that phase specifically. It only mentioned that ClassfileParse can be called late (e.g. at flatten phase) and we make to make sure we handle such situation properly.

   Attributes
     protected

4. #### abstract def newConstantPool: ThisConstantPool

   Attributes
     protected

5. #### abstract val symbolTable: SymbolTable { def settings: scala.tools.nsc.Settings }

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ClassfileParser to any2stringadd[ClassfileParser] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ClassfileParser, B)

   Implicit information
     This member is added by an implicit conversion from ClassfileParser to ArrowAssoc[ClassfileParser] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### def addEnclosingTParams(clazz: (symbolTable)#Symbol): Unit

   Add type parameters of enclosing classes

7. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

8. #### var busy: (symbolTable)#Symbol

   Attributes
     protected

9. #### def classNameToSymbol(name: (symbolTable)#Name): (symbolTable)#Symbol

   Return the class symbol of the given name.

10. #### var classTParams: Map[(symbolTable)#Name, (symbolTable)#Symbol]

    Attributes
      protected

11. #### var clazz: (symbolTable)#Symbol

    Attributes
      protected

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

13. #### var currentClass: (symbolTable)#Name

    Attributes
      protected

14. #### def ensuring(cond: (ClassfileParser) ⇒ Boolean, msg: ⇒ Any): ClassfileParser

    Implicit information
      This member is added by an implicit conversion from ClassfileParser to Ensuring[ClassfileParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: (ClassfileParser) ⇒ Boolean): ClassfileParser

    Implicit information
      This member is added by an implicit conversion from ClassfileParser to Ensuring[ClassfileParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean, msg: ⇒ Any): ClassfileParser

    Implicit information
      This member is added by an implicit conversion from ClassfileParser to Ensuring[ClassfileParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean): ClassfileParser

    Implicit information
      This member is added by an implicit conversion from ClassfileParser to Ensuring[ClassfileParser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

19. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

20. #### var file: AbstractFile

    Attributes
      protected

21. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

22. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ClassfileParser to StringFormat[ClassfileParser] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

23. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

24. #### def getScope(flags: JavaAccFlags): (symbolTable)#Scope

    Attributes
      protected

25. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

26. #### var in: AbstractFileReader

    Attributes
      protected

27. #### object innerClasses

    Return the class symbol for the given name.

    Return the class symbol for the given name. It looks it up in its outer class. Forces all outer class symbols to be completed.

    If the given name is not an inner class, it returns the symbol found in `definitions`.

28. #### var instanceScope: (symbolTable)#Scope

    Attributes
      protected

29. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

30. #### var isScala: Boolean

    Attributes
      protected

31. #### var isScalaAnnot: Boolean

    Attributes
      protected

32. #### var isScalaRaw: Boolean

    Attributes
      protected

33. #### def moduleClass: (symbolTable)#Symbol

    Attributes
      protected

34. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

35. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

36. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

37. #### def parse(file: AbstractFile, root: (symbolTable)#Symbol): Unit

38. #### def parseAttributes(sym: (symbolTable)#Symbol, symtype: (symbolTable)#Type): Unit

39. #### def parseClass(): Unit

40. #### def parseField(): Unit

41. #### def parseInnerClasses(): Unit

    Parse inner classes.

    Parse inner classes. Expects `in.bp` to point to the superclass entry. Restores the old `bp`.

42. #### def parseMethod(): Unit

43. #### var pool: ThisConstantPool

    Attributes
      protected

44. #### def skipAttributes(): Unit

45. #### def skipMembers(): Unit

46. #### def skipSuperclasses(): Unit

47. #### def srcfile: Option[AbstractFile]

48. #### var srcfile0: Option[AbstractFile]

    Attributes
      protected

49. #### var staticModule: (symbolTable)#Symbol

    Attributes
      protected

50. #### var staticScope: (symbolTable)#Scope

    Attributes
      protected

51. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

52. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

53. #### final def u1(): Int

    Attributes
      protected

54. #### final def u2(): Int

    Attributes
      protected

55. #### final def u4(): Int

    Attributes
      protected

56. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

57. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

58. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

59. #### def →[B](y: B): (ClassfileParser, B)

    Implicit information
      This member is added by an implicit conversion from ClassfileParser to ArrowAssoc[ClassfileParser] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ClassfileParser to any2stringadd[ClassfileParser]

### Inherited by implicit conversion StringFormat from ClassfileParser to StringFormat[ClassfileParser]

### Inherited by implicit conversion Ensuring from ClassfileParser to Ensuring[ClassfileParser]

### Inherited by implicit conversion ArrowAssoc from ClassfileParser to ArrowAssoc[ClassfileParser]

### Ungrouped